#
# (P) Marathon2010, last change 1-Sep-23 
#
function exitError {
   echo "ERROR: $1"
   if [ "$2" == "logout" ]; then logout; fi
   endLogging
   exit 1
}

function beginLogging {
   echo "Audio log Domoticz Streaming. Logged date/time is $(date +'%a %d-%b-%y %H:%M:%S')"
   echo "------------------------------------------------------------------------"
   echo "Version 3.2 (1-Sep-23)"
   echo ""
}

function endLogging {
   echo ""
   echo "----------------------------------------------------------------------------"
   echo "End Audio log Domoticz Streaming. Logged date/time is $(date +'%a %d-%b-%y %H:%M:%S')"
}

function executeURL {
   urlstring=$1
   cookiejar=$2       # options are 1) -jar (implies save the cookie file) or 2) everything else (implies load the cookie file)
   if [ "$cookiejar" != "-jar" ]; then cookiejar=""; fi
   result=$(curl --silent --cookie$cookiejar $cookiefile $urlstring) 
   echo $result
}

function urlToExecute {
   urlString=$1
   cookieOption=$2
   textString=$3
   result=$(executeURL "$urlString" "$cookieOption")
   echoDebug ""
   echoDebug "Url        : $urlString"
   echoDebug "Response   : $result"
   isSuccess=$(echo $result | jq '.success')
   echo ""
   echo "$textString $isSuccess."
}

function echoDebug {
   showString=$1
   if [ "$showDebugMessagesIndicator" == "Y" ]; then echo "$showString"; fi
}

function login {
   account=$1
   password=$2
   urlToExecute "$pathAuthorization$apiAuthorization&version=6&method=login&account=$account&passwd=$password&enable_syno_token=yes" "-jar" "Login account '$account':"
   synotoken=""
   if [ "$isSuccess" != "true" ]
   then
      exitError "Failed logging in, exiting now." ""
   else
      synotoken=$(echo $result | jq '.data.synotoken')               # retrieve from response
      synotoken=$(echo "$synotoken" | tr -d '"')                     # get rid of quotes
      echo "Login token: "$synotoken
      synotoken="&SynoToken="$synotoken                              # define string to add to requests

      didlogin=$(echo $result | jq '.data.did')                      # retrieve from response
      didlogin=$(echo "$didlogin" | tr -d '"')                       # get rid of quotes
      echoDebug "Login DID  : "$didlogin

      sidlogin=$(echo $result | jq '.data.sid')                      # retrieve from response
      sidlogin=$(echo "$sidlogin" | tr -d '"')                       # get rid of quotes
      echoDebug "Login SID  : "$sidlogin
      sidlogin="&_sid="$sidlogin                                     # define string to add to requests
   fi
}

function logout {
   urlToExecute "$pathAuthorization$apiAuthorization&version=6&method=logout&session=AudioStation" "loadcookie" "Logout account '$account':"
}