#
# (P) Marathon2010, last change 1-Sep-23 
#
##### INPUT PARAMETERS
#
   currentStreamId=$1                      # what channel is currently selected in Domoticz.
   newStreamId=$2                          # what new channel has been selected in Domoticz.
   numberStreams=$3                        # what is the number of streams in the playlist of Domoticz.
   remotePlayerName=$4                     # what is the name of the player to be used to play the stream.
   playlistName=$5                         # what is the name of the playlist to be played on the player.
   volumeReceiver=$6                       # what is the requested volume level.
   indicator1=$7                           # option to the command (so -D or -L).
   indicator2=$8                           # option to the command (so -D or -L).
#
##### START LOGGING
#
   beginLogging
#
##### CHECK INPUT
#
   if [ "$currentStreamId" == "" ];                           then exitError "Current Stream id is not supplied." "";                                                                fi
   if [ "$newStreamId" == "" ];                               then exitError "New Stream id is not supplied." "";                                                                    fi
   if [ "$numberStreams" == "" ];                             then exitError "Number of Streams is not supplied." "";                                                                fi
   if [ "$remotePlayerName" == "" ];                          then exitError "Receiver name is not supplied." "";                                                                    fi
   if [ "$playlistName" == "" ];                              then exitError "Playlist name is not supplied." "";                                                                    fi
   if [ "$volumeReceiver" == "" ];                            then exitError "Volume level is not supplied." "";                                                                     fi

   if ! [[ $currentStreamId =~ ^[0-9]+$ ]];                   then exitError "Current Stream id ($currentStreamId) not a number." "";                                                fi
   if ! [[ $newStreamId =~ ^[0-9]+$ ]];                       then exitError "New Stream id ($newStreamId) not a number." "";                                                        fi
   if ! [[ $numberStreams =~ ^[0-9]+$ ]];                     then exitError "Number of streams ($numberStreams) not a number." "";                                                  fi
   if ! [[ $volumeReceiver =~ ^[0-9]+$ ]];                    then exitError "Volume level ($volumeReceiver) not a number." "";                                                      fi

   if [ $currentStreamId -ge $numberStreams ];                then exitError "Current Stream id ($currentStreamId) bigger then Number of Streams ($numberStreams) not a number." ""; fi
   if [ $newStreamId -ge $numberStreams ];                    then exitError "New Stream id ($newStreamId) bigger then Number of Streams ($numberStreams) not a number." "";         fi

   if [ "$indicator1" == "-D" ] || [ "$indicator2" == "-D" ]; then showDebugMessagesIndicator="Y"; else showDebugMessagesIndicator="N";                                              fi
   if [ "$indicator1" == "-L" ] || [ "$indicator2" == "-L" ]; then clearPlaylistIndicator="Y"; else clearPlaylistIndicator="N";                                                      fi

   echo "Input is checked and fine."
   echo ""
#
##### SHOW VALUES
#
   echo "Map        : $DIR"
   echo "Parameters : Stream = '$currentStreamId' NewStream = '$newStreamId' Total Streams = '$numberStreams'"
   echo "Receiver   : Player = '$remotePlayerName' Playlist = '$playlistName' Volume = '$volumeReceiver'"
   echo "Indicators : Debug  = '$showDebugMessagesIndicator' ClearPlayList = '$clearPlaylistIndicator'"