#!/bin/sh
#
#  (P) Marathon2010, last change 2-Sep-23
#
   DIR="${BASH_SOURCE%/*}"
   if [[ ! -d "$DIR" ]]; then DIR="$PWD"; fi
#
##### INITIALISATION
#--------------------------------
   source "$DIR/config.sh"
   source "$DIR/base_modules.sh"
   source "$DIR/init.sh"
#--------------------------------
###### LOGIN
   login $account $password
#
###### DETERMINE INTERNAL PLAYER ID
   urlToExecute "$pathPlayer$apiPlayer$synotoken&method=list&library=shared&version=2" "loadcookie" "Player determined:"
   remotePlayerId=$(echo "$result" | jq --arg PLAYERNAME "$remotePlayerName" -r '.data.players[] | select(.name == $PLAYERNAME) | .id')
   if [ "$remotePlayerId" == "$result" ]; then exitError "Player is not powered." "logout"; fi
   if [ "$isSuccess" != "true" ]        ; then exitError "Failed Player determining." "logout"; fi
   echo "Determined PlayerId: $remotePlayerId [$remotePlayerName]."
#
###### DETERMINE INTERNAL PLAYLIST ID
   urlToExecute "$pathPlaylist$apiPlaylist$synotoken&method=list&library=all&limit=100000&version=3" "loadcookie" "Playlist determined:"
   playlistId=$(echo "$result" | jq --arg PLAYLIST "$playlistName" -r '.data.playlists[] | select(.name == $PLAYLIST) | .id')
   if [ "$isSuccess" != "true" ]; then exitError "Failed Playlist determining." "logout"; fi
   echo "Determined PlaylistId: $playlistId [$playlistName]."
#
###### RETRIEVE LOADED STREAMS IN MEMORY RECEIVER - REQUIRED TO DETERMINE NUMBER OF STREAMS TO CLEAR IN NEXT STEP
   urlToExecute "$pathPlayer$apiPlayer$synotoken&method=getplaylist&id=$remotePlayerId&offset=0&limit=8192&version=3" "loadcookie" "Loaded Streams:"
   playlistLoaded=$(echo $result | jq '.data.total')
   echo "Number of Loaded Streams: $playlistLoaded"
#
###### ONLY PLAY CURRENT/NEW STREAM OR FIRST NEED TO CLEAR AND LOAD PLAYLIST
   if [ "$clearPlaylistIndicator" == "Y" ]
   then
#
###### CLEAR LOADED STREAMS
      urlToExecute "$pathPlayer$apiPlayer$synotoken&method=updateplaylist&library=shared&id=$remotePlayerId&offset=0&updated_index=-1&limit=$playlistLoaded&play=false&version=2&songs=" "loadcookie" "Cleared Streams:"
#
###### LOADED INTERNET RADIO STREAM
      playlistIdBase=$(echo "$playlistId" | cut -d "/" -f 1)                                                                    # string before the /
      playlistIdExtension=$(echo "$playlistId" | cut -d "/" -f 2)                                                               # string after the /
      playlistString="%5B%7B%22type%22%3A%22playlist%22%2C%22id%22%3A%22$playlistIdBase%2F$playlistIdExtension%22%7D%5D"        # format the playlist in HEX
      urlToExecute "$pathPlayer$apiPlayer$synotoken&method=updateplaylist&id=$remotePlayerId&library=shared&limit=0&offset=0&play=true&version=3&keep_shuffle_order=false&containers_json=$playlistString" "loadcookie" "Load Stream $playlistName:"
#
###### RETRIEVE LOADED STREAMS IN MEMORY RECEIVER
      urlToExecute "$pathPlayer$apiPlayer$synotoken&method=getplaylist&id=$remotePlayerId&offset=0&limit=8192&version=3" "loadcookie" "Loaded Streams:"
      playlistLoaded=$(echo $result | jq '.data.total')
      echo "Number of Loaded Streams: $playlistLoaded"
   fi
#
###### CHECK LOADED VS DOMOTICZ STREAMS
   if [ $numberStreams != $playlistLoaded ]; then echo "Mismatch Domoticz ($numberStreams) vs Loaded Streams ($playlistLoaded)"; fi
#
###### PLAY STREAM
   urlToExecute "$pathPlayer$apiPlayer$synotoken&method=control&id=$remotePlayerId&version=3&action=play&value=$newStreamId" "loadcookie" "Playing Stream:"
#
###### SET VOLUME
   if [ $volumeReceiver != 0 ]; then urlToExecute "$pathPlayer$apiPlayer$synotoken&method=control&id=$remotePlayerId&version=3&action=set_volume&value=$volumeReceiver" "loadcookie" "Volume adjustment:"; fi
#
###### LOGOUT AND END LOGGING
   logout                    
   endLogging